<?php
	require_once("Autor.php");
	require_once("Revisao.php");

	class Artigo {
		private $codigo;
		private $titulo;
		private $contato;
		private $arrayAutores;		
		private $arrayRevisoes;	
		private $mediaNotas;

		public function __construct($codigo, $titulo) {
			$this->codigo = $codigo;
			$this->titulo = $titulo;
		}
		
		public function getAutores() {
			return $this->arrayAutores;
		}

		public function setAutores($arrayAutores) {
			$this->arrayAutores = $arrayAutores;
		}

		public function inserirAutor($autor) {
			$this->arrayAutores[] = $autor;
		}

		public function getRevisao() {
			return $this->arrayRevisoes;
		}
		
		public function getRevisores() {
			return $this->arrayRevisoes;
		}
		
		public function setRevisoes($arrayRevisoes) {
			$this->arrayRevisoes = $arrayRevisoes;
		}
		
		public function addRevisao ($revisao) {
			$this->arrayRevisoes[] = $revisao;
		}
		
		public function getContato() {
			return $this->contato;
		}

		public function setContato($contato) {
			$this->contato = $contato;
		}

		public function getTitulo() {
			return $this->titulo;
		}

		public function setTitulo($titulo) {
			$this->titulo = $titulo;
		}

		public function getCodigo() {
			return $this->codigo;
		}
	
		public function getAutorArtigo($codigo) {
			foreach($this->arrayAutores as $a) {
				if($a->getCodigo() == $codigo) {
					return $a;
				}
			}
			return NULL;
		}
		
		public function toString() {
			return "[ " . $this->titulo . ", cod: " . $this->codigo . "\n";
		}
		
		public function getRevisoes() {
			return $this->arrayRevisoes;
		}

		//Calcula e armazena no artigo a media das notas recebidas dos revisores.
		public function computarMedia() {
			$soma = $this->arrayRevisoes[0]->getMediaNotas() + $this->arrayRevisoes[1]->getMediaNotas() + $this->arrayRevisoes[2]->getMediaNotas();
			$this->mediaNotas = $soma/3;
		}

		public function getMediaNotas() {
			return $this->mediaNotas;
		}
			
	}
?>	

