<?php	
	
	require_once("GeradorRelatorio.php");
	require_once ("Revista.php");
	require_once ("Leitor.php");
	require_once ("Tema.php");
	
	//Recebe uma string a ser pesquisada, um vetor de strings contendo 
	//os parametros de entrada e um inteiro representando o tamanho desse vetor.
	//Procura no vetor de entrada os caminhos para os arquivos a serem lidos.
	//Retorna o caminho do arquivo procurado ou NULL, se o arquivo procurado nao e encontrado.
	function procuraParametro($string, $numParametros, $vetorParametros)
	{
		for ($i = 1; $i < $numParametros ; $i++) {
			if ($vetorParametros[$i] == $string)
				return $vetorParametros[$i + 1];
		}
		return NULL;
	}

	echo "==== Gerador de Relatorios 1.0 ====\n";

	if ($argc == 1) {
		echo "Favor inserir parâmetros.\n";
		exit(0);
	}

	
		
	
	$engesoft = new Revista("EngeSoft");
	$leitor = new Leitor();
	
	
	//LENDO PESSOAS
	$nome_arquivo = procuraParametro("-p", $argc, $argv);
	if ($nome_arquivo == NULL) {
		echo "Erro: Arquivo de pessoas não encontrado.\n";
		exit(0);
	}
	else
		echo "Lendo: " . $nome_arquivo . "\n";

	$leitor->lerArquivoPessoas($nome_arquivo, $engesoft);
	//$engesoft->printAutores();
	//$engesoft->printRevisores();
		
		
	//LENDO TEMAS
	$nome_arquivo = procuraParametro("-t", $argc, $argv);
	if ($nome_arquivo == NULL) {
		echo "Erro: Arquivo de temas não encontrado.\n";
		exit(0);
	}
	else
		echo "Lendo: " . $nome_arquivo . "\n";

	$leitor->lerArquivoTemas($nome_arquivo, $engesoft);
	//$engesoft->printTemas();


	//LENDO EDICAO
	$nome_arquivo = procuraParametro("-e", $argc, $argv);
	if ($nome_arquivo == NULL) {
		echo "Erro: Arquivo de edição não encontrado.\n";
		exit(0);
	}
	else
		echo "Lendo: " . $nome_arquivo . "\n";

	$leitor->lerArquivoEdicao($nome_arquivo, $engesoft);
	//$engesoft->printEdicao();
		
		
	//LENDO ARTIGOS
	$nome_arquivo = procuraParametro("-a", $argc, $argv);
	if ($nome_arquivo == NULL) {
		echo "Erro: Arquivo de artigos não encontrado.\n";
		exit(0);
	}
	else
		echo "Lendo: " . $nome_arquivo . "\n";

	$leitor->lerArquivoArtigos($nome_arquivo, $engesoft);
	//$engesoft->printArtigos();
		
		
	//LENDO REVISOES
	$nome_arquivo = procuraParametro("-r", $argc, $argv);
	if ($nome_arquivo == NULL) {
		echo "Erro: Arquivo de revisoes não encontrado.\n";
		exit(0);
	}
	else
		echo "Lendo: " . $nome_arquivo . "\n";

	$leitor->lerArquivoRevisoes($nome_arquivo, $engesoft);
	//$engesoft->printRevisoes();
	
	$gerRelat = new GeradorRelatorio();
	$gerRelat->gerarResumo($engesoft);
	$gerRelat->gerarRelatorioRevisores($engesoft);
	$gerRelat->gerarRelatorioRevisoes($engesoft);
	echo "Relatórios gerados!\n";

?>
