<?php

	require_once("Autor.php");
	require_once("Revisor.php");
	require_once("Artigo.php");
	require_once("Tema.php");
	require_once("Revisao.php");
	require_once("Edicao.php");	

	class Revista {
		private $nome;
		private $arrayAutores;
		private $arrayRevisores;	//Map<Integer,Revisor> revisores;
		private $arrayArtigos;		//Map<Integer,Artigo> artigos;
		private $arrayTemas;		//Map<Integer,Tema> temas;
		private $arrayRevisoes;		//Set<Revisao> revisoes;
		private $edicao;

		public function __construct($nome) {
			$this->nome = $nome;;
		}	

		public function getNome() {
			return $this->nome;
		}

		public function setNome($nome) {
			$this->nome = $nome;
		}
		
		public function getEdicao() {
			return $this->edicao;
		}
		
		public function setEdicao($edicao) {
			$this->edicao = $edicao;
		}

		//--------Metodos Autor----------

		public function getAutores() {
			return $this->arrayAutores;
		}
	
		public function printAutores() {
			foreach ($this->arrayAutores as $k => $v) {
				echo  $v->toString();
			}
		}
	
		public function addAutor($codigo, $autor) {
			$this->arrayAutores[$codigo] = $autor;
		}
	
		public function getAutor ($codigo) {
			return $this->arrayAutores[$codigo];
		}
		
		//--------Metodos Revisor---------		
		
		public function addRevisor ($codigo, $revisor) {
			$this->arrayRevisores[$codigo] = $revisor;
		}
			
		public function getRevisor($codigo) {
			return $this->arrayRevisores[$codigo];
		}

		public function getRevisores () {
			return $this->arrayRevisores;
		}

		public function getRevisorPorNome($nome_revisor) {
			foreach ($this->arrayRevisores as $k => $r) {
				if ($r->getNome() == $nome_revisor)
					return $r;
			}
			return NULL;
		}
		
		public function printRevisores() {
			foreach ($this->arrayRevisores as $k => $v) {
				echo  $v->toString();
			}
		}
		
		//Retorna um inteiro representando o numero de revisores capacitados 
		// a avaliar o tema da edicao atual desta revista.
		public function getNumRevisoresCapacitados() {
			return $this->getEdicao()->getTema()->getNumeroRevisores();
		}
		
		//Retorna um inteiro representando o numero de revisores envolvidos 
		// na revisao dos artigos da edicao atual desta revista.
		public function getNumRevisoresEnvolvidos() {
			$revisoresEnvolvidos = array();
			for ($i = 0; $i < count($this->arrayRevisoes); $i++) {
				$revisor = $this->arrayRevisoes[$i]->getRevisor();
				if ( !in_array($revisor, $revisoresEnvolvidos) )
					$revisoresEnvolvidos[] = $revisor;
			}
			return count($revisoresEnvolvidos);
		}   

		//--------Metodos Tema---------			

		public function addTema ($codigo, $tema) {
			$this->arrayTemas[$codigo] = $tema;
		}
		
		public function printTemas() {
			foreach ($this->arrayTemas as $k => $t) {
				echo  $t->toString();
				$t->printRevisores();
			}
		}
		
		public function getTema($nome_tema) {			
			foreach ($this->arrayTemas as $k => $t) {
				if ($t->getNome() == $nome_tema) {
					return $t;
				}
			}
			return NULL;
		}
		
		//--------Metodo Edicao--------	
			
		public function printEdicao() {
				$e = $this->edicao;
				echo $e->toString();
		}
		
		//--------Metodos Artigo---------		

		public function addArtigo ($codigo, $artigo) {
			$this->arrayArtigos[$codigo] = $artigo;
		}
		
		public function getArrayArtigos() {
			return $this->arrayArtigos;
		}		

		public function getArtigo($cod) {
			return $this->arrayArtigos[$cod];
		}
		
		public function getNumArtigos() {
			return count($this->arrayArtigos);
		}
		
		public function printArtigos() {
			foreach ($this->arrayArtigos as $k => $a) {
				echo  $a->toString();
			}
		}

		//--------Metodos Revisao---------		
		
		public function getRevisoes() {
			return $this->arrayRevisoes;
		}
		
		public function addRevisao($revisao) {
			$this->arrayRevisoes[] = $revisao;
		}
			
		public function printRevisoes()  {
			foreach ($this->arrayRevisoes as $r) {
				echo  $r->toString();
			}
		}
	
}		
	
?>
